"use strict";
/**
 * responsible to wire everything together
 */
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.HavenWallet = void 0;
const electron_1 = require("electron");
const path = __importStar(require("path"));
const LocalNodeHandler_1 = require("./localNode/LocalNodeHandler");
const EventBus_1 = require("./EventBus");
const WalletHandler_1 = require("./wallets/WalletHandler");
class HavenWallet {
    constructor() {
        this._isRunning = false;
        this.walletHandler = new WalletHandler_1.WalletHandler();
        this.localNodeHandler = new LocalNodeHandler_1.LocalNodeHandler();
        this.requestShutDown = false;
    }
    /**
     * Initializes the wallet by creating wallet dir, starting the Daemon, and initializing wallet handlers
     */
    start() {
        if (this._isRunning) {
            return;
        }
        this._isRunning = true;
        this.walletHandler.start();
    }
    quit() {
        this.requestShutDown = true;
        this.showShutDownWindow();
        this.localNodeHandler.stop();
        this.walletHandler.quit();
        this._isRunning = false;
    }
    /**
     * display shut down window and once stop event is emitted destroys the window
     */
    showShutDownWindow() {
        const shutDownConctruction = {
            width: 500,
            height: 280,
            center: true,
            alwaysOnTop: true,
            closable: true,
            resizable: false,
            movable: true,
            frame: false,
            fullscreenable: false,
            kiosk: true,
        };
        this.shutDownWindow = new electron_1.BrowserWindow(shutDownConctruction);
        this.shutDownWindow.loadURL(path.join(`file://${__dirname}`, "../sites/shutdown/index.html"));
        this.shutDownWindow.on("ready-to-show", () => {
            this.shutDownWindow.show();
        });
        EventBus_1.appEventBus.once(EventBus_1.LOCAL_NODE_STOPPED_EVENT, () => this.shutDownWindow.destroy());
    }
}
exports.HavenWallet = HavenWallet;
