"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.addConfigHandler = void 0;
const electron_1 = require("electron");
const types_1 = require("../types");
const fs = __importStar(require("fs"));
const path = __importStar(require("path"));
const env_1 = require("../env");
const dev_1 = require("../dev");
const CONFIG_FILE_NAME = "haven_config";
const configFilePath = path.join(env_1.APP_DATA_PATH, CONFIG_FILE_NAME);
const addConfigHandler = () => {
    if (!isConfigCreated()) {
        createDefaultConfig();
    }
    electron_1.ipcMain.handle(types_1.CommunicationChannel.CONFIG, (event, args) => {
        (0, dev_1.logInDevMode)(args);
        if (Array.isArray(args)) {
            return getConfig(args[0], args[1]);
        }
        return getConfig(args);
    });
};
exports.addConfigHandler = addConfigHandler;
const getConfig = (netTypeID, update = undefined) => {
    const fileBuffer = fs.readFileSync(configFilePath + `_${netTypeID}`);
    const currentConfig = JSON.parse(fileBuffer.toString());
    // if args sent by client, update config
    if (update) {
        const updatedConfig = { ...currentConfig, ...update };
        const configJson = JSON.stringify(updatedConfig);
        fs.writeFileSync(configFilePath + `_${netTypeID}`, configJson, "utf8");
        return updatedConfig;
    }
    return currentConfig;
};
const isConfigCreated = () => {
    return fs.existsSync(configFilePath + `_${types_1.NET.Mainnet}`);
};
const createDefaultConfig = () => {
    // we just create a simple default config
    const defaultConfig = {
        selectedNode: {
            location: types_1.NodeLocation.None
        },
        theme: "dark"
    };
    const configJson = JSON.stringify(defaultConfig);
    fs.writeFileSync(configFilePath + `_${types_1.NET.Mainnet}`, configJson, "utf8");
    fs.writeFileSync(configFilePath + `_${types_1.NET.Testnet}`, configJson, "utf8");
    fs.writeFileSync(configFilePath + `_${types_1.NET.Stagenet}`, configJson, "utf8");
};
