"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.startInDevMode = exports.logInDevMode = exports.destroySocket = void 0;
const net = __importStar(require("net"));
const rxjs_1 = require("rxjs");
const env_1 = require("./env");
const path = __importStar(require("path"));
const devServerStartedObservable = new rxjs_1.BehaviorSubject(false);
const devServerStarted = devServerStartedObservable.asObservable();
const client = new net.Socket();
const tryConnection = () => {
    client.connect({ port: 3000 }, () => {
        devServerStartedObservable.next(true);
    });
};
tryConnection();
client.on("error", (error) => {
    devServerStartedObservable.next(false);
    setTimeout(tryConnection, 1000);
});
const destroySocket = () => {
    client.destroy();
};
exports.destroySocket = destroySocket;
const logInDevMode = (mes) => {
    if (env_1.isDevMode) {
        console.log(mes);
    }
};
exports.logInDevMode = logInDevMode;
const startInDevMode = (mainWindow) => {
    mainWindow.webContents.openDevTools();
    devServerStarted.subscribe((hasStarted) => {
        console.log("hasStarted : ", hasStarted);
        if (hasStarted) {
            mainWindow.loadURL("http://localhost:3000");
        }
        else {
            mainWindow.loadURL(path.join(`file://${__dirname}`, "../sites/dev/index.html"));
        }
    });
};
exports.startInDevMode = startInDevMode;
