"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.mainWindow = void 0;
const electron_1 = require("electron");
const path = __importStar(require("path"));
const appConfig_1 = require("./config/appConfig");
const dev_1 = require("./dev");
const env_1 = require("./env");
const EventBus_1 = require("./EventBus");
const HavenWallet_1 = require("./HavenWallet");
const menu_1 = require("./menu");
electron_1.app.enableSandbox();
// Handle creating/removing shortcuts on Windows when installing/uninstalling.
// tslint:disable-next-line: no-var-requires
if (require("electron-squirrel-startup")) {
    electron_1.app.quit();
}
// Keep a global reference of the window object, if you don't, the window will
// be closed automatically when the JavaScript object is garbage collected.
let mainWindow;
exports.mainWindow = mainWindow;
const wallet = new HavenWallet_1.HavenWallet();
(0, menu_1.createMenu)();
const startApp = () => {
    const browserOptions = {
        width: 992,
        minWidth: 470,
        minHeight: 720,
        height: 750,
        /// icon:path.join(__dirname, "../icons/icon.png"),
    };
    browserOptions.webPreferences = {
        contextIsolation: true,
        //enableRemoteModule: false,
        nodeIntegration: false,
        additionalArguments: [electron_1.app.getVersion()],
        preload: path.join(__dirname, "../sites/preload/preload.js"),
    };
    // Create the browser window.
    exports.mainWindow = mainWindow = new electron_1.BrowserWindow(browserOptions);
    if (env_1.isDevMode) {
        // Open the DevTools.
        (0, dev_1.startInDevMode)(mainWindow);
    }
    else {
        // and load the index.html of the app.
        mainWindow.loadURL(path.join(`file://${__dirname}`, "../client/index.html"));
    }
    // start the app
    wallet.start();
    //
    (0, appConfig_1.addConfigHandler)();
    // Emitted when the window is closed.
    mainWindow.on("closed", () => {
        // Dereference the window object, usually you would store windows
        // in an array if your app supports multi windows, this is the time
        // when you should delete the corresponding element.
        exports.mainWindow = mainWindow = null;
    });
    mainWindow.on("ready-to-show", () => {
        mainWindow.show();
    });
};
//app.commandLine.appendSwitch('--js-flags', '--experimental-wasm-threads');
//app.commandLine.appendSwitch('--js-flags', '--experimental-wasm-bulk-memory');
// This method will be called when Electron has finished
// initialization and is ready to create browser windows.
// Some APIs can only be used after this event occurs.
electron_1.app.on("ready", startApp);
let willQuit = false;
electron_1.app.on("will-quit", (event) => {
    if (!willQuit) {
        willQuit = true;
        event.preventDefault();
        onAppQuit();
    }
});
// Quit when all windows are closed.
electron_1.app.on("window-all-closed", () => {
    electron_1.app.quit();
});
electron_1.app.on("web-contents-created", (event, contents) => {
    contents.setWindowOpenHandler((details) => {
        electron_1.shell.openExternal(details.url);
        return { action: 'deny' };
    });
});
const onAppQuit = () => {
    console.log("on App quit called");
    EventBus_1.appEventBus.once(EventBus_1.LOCAL_NODE_STOPPED_EVENT, () => {
        electron_1.app.quit();
    });
    wallet.quit();
};
