"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getLocalNodeArguments = exports.getLocalDaemonPath = exports.checkForUnpackedPath = void 0;
const path = __importStar(require("path"));
const env_1 = require("../env");
const types_1 = require("../types");
const PLATFORM = process.platform;
function checkForUnpackedPath(pathName) {
    if (!pathName.includes("app.asar.unpacked")) {
        return pathName.replace("app.asar", "app.asar.unpacked");
    }
    return pathName;
}
exports.checkForUnpackedPath = checkForUnpackedPath;
const getLocalDaemonPath = (netTypeID) => {
    return checkForUnpackedPath(path.resolve(__dirname, `../haven-node/${PLATFORM}/${(0, env_1.getNetTypeName)(netTypeID)}/havend`));
};
exports.getLocalDaemonPath = getLocalDaemonPath;
const getLocalNodeArguments = (netTypeId) => {
    switch (netTypeId) {
        case types_1.NET.Mainnet:
            return {};
        case types_1.NET.Testnet:
            return {
                "testnet": "",
                "add-priority-node": "seed01.testnet.havenprotocol.org",
            };
        case types_1.NET.Stagenet:
            return {
                "stagenet": "",
                "offline": "",
                "fixed-difficulty": 50,
            };
    }
};
exports.getLocalNodeArguments = getLocalNodeArguments;
