"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.deleteAddressBookEntry = exports.editAddressBookEntry = exports.addAddressBookEntry = exports.getAddressBookEntries = exports.saveWallet = exports.rescanSpent = exports.isClosed = exports.rescanBlockchain = exports.getSyncHeight = exports.setSyncHeight = exports.getIntegratedAddress = exports.labelAddress = exports.createSubAddress = exports.getSubAddresses = exports.addWalletListener = exports.getKeys = exports.setDaemonConnection = exports.relayTxs = exports.isWalletConnected = exports.isWalletSynced = exports.getTxs = exports.getTransfers = exports.sweep = exports.transfer = exports.syncAtOnce = exports.stopSyncing = exports.syncWallet = exports.getChainHeight = exports.getNodeHeight = exports.getWalletHeight = exports.getPrimaryAddress = exports.getPrivateView = exports.getPublicView = exports.getPrivateSpend = exports.getPublicSpend = exports.getMnemonic = exports.getWalletData = exports.getUnlockedBalance = exports.getBalance = exports.getMaxDestinationAmount = exports.getCirculatingSupply = exports.getCollateralRequirements = exports.getBlockCap = exports.closeWallet = exports.openWallet = exports.createWallet = void 0;
const core = __importStar(require("haven-wallet-core"));
let wallet;
const createWallet = async (walletData) => {
    wallet = await core.createWalletFull(walletData);
    return true;
};
exports.createWallet = createWallet;
const openWallet = async (walletData) => {
    wallet = await core.openWalletFull(walletData);
    return true;
};
exports.openWallet = openWallet;
const closeWallet = async (save) => {
    //@ts-ignore
    return wallet.close(save);
};
exports.closeWallet = closeWallet;
const getBlockCap = async () => {
    //@ts-ignore
    return wallet.getBlockCap();
};
exports.getBlockCap = getBlockCap;
const getCollateralRequirements = async (sourceAssetType, destinationAssetType, amount) => {
    //@ts-ignore
    const requiredCollateral = await wallet.getCollateralRequirements(sourceAssetType, destinationAssetType, amount);
    return requiredCollateral;
};
exports.getCollateralRequirements = getCollateralRequirements;
const getCirculatingSupply = async () => {
    //@ts-ignore
    return wallet.getCirculatingSupply();
};
exports.getCirculatingSupply = getCirculatingSupply;
const getMaxDestinationAmount = async (sourceAssetType, destinationAssetType) => {
    //@ts-ignore
    return wallet.getMaxDestinationAmount(sourceAssetType, destinationAssetType);
};
exports.getMaxDestinationAmount = getMaxDestinationAmount;
const getBalance = async (accountIdx = undefined, subaddressIdx = undefined, assetType = undefined) => {
    if (!wallet) {
        throw Error("no wallet exist");
    }
    //@ts-ignore
    const balance = await wallet.getBalance();
    return balance;
};
exports.getBalance = getBalance;
const getUnlockedBalance = async (accountIdx = undefined, subaddressIdx = undefined, assetType = undefined) => {
    if (!wallet) {
        throw Error("no wallet exist");
    }
    const balance = await wallet.getUnlockedBalance(
    //@ts-ignore
    accountIdx, subaddressIdx, assetType);
    return balance;
};
exports.getUnlockedBalance = getUnlockedBalance;
const getWalletData = async () => {
    return wallet.getData();
};
exports.getWalletData = getWalletData;
const getMnemonic = async () => {
    return wallet.getMnemonic();
};
exports.getMnemonic = getMnemonic;
const getPublicSpend = async () => {
    return wallet.getPublicSpendKey();
};
exports.getPublicSpend = getPublicSpend;
const getPrivateSpend = async () => {
    return wallet.getPrivateSpendKey();
};
exports.getPrivateSpend = getPrivateSpend;
const getPublicView = async () => {
    return wallet.getPublicViewKey();
};
exports.getPublicView = getPublicView;
const getPrivateView = async () => {
    return wallet.getPrivateViewKey();
};
exports.getPrivateView = getPrivateView;
const getPrimaryAddress = async () => {
    return wallet.getPrimaryAddress();
};
exports.getPrimaryAddress = getPrimaryAddress;
const getWalletHeight = async () => {
    return wallet.getHeight();
};
exports.getWalletHeight = getWalletHeight;
const getNodeHeight = async () => {
    return wallet.getDaemonHeight();
};
exports.getNodeHeight = getNodeHeight;
const getChainHeight = async () => {
    return wallet.getDaemonMaxPeerHeight();
};
exports.getChainHeight = getChainHeight;
const syncWallet = () => {
    //@ts-ignore
    return wallet.startSyncing();
};
exports.syncWallet = syncWallet;
const stopSyncing = () => {
    return wallet.stopSyncing();
};
exports.stopSyncing = stopSyncing;
const syncAtOnce = (startHeight) => {
    //@ts-ignore
    return wallet.sync(startHeight);
};
exports.syncAtOnce = syncAtOnce;
const transfer = async (txConfig) => {
    //@ts-ignore
    return wallet.createTxs(txConfig);
};
exports.transfer = transfer;
const sweep = async (txConfig) => {
    return wallet.sweepUnlocked(txConfig);
};
exports.sweep = sweep;
const getTransfers = async () => {
    //@ts-ignore
    return wallet.getTransfers();
};
exports.getTransfers = getTransfers;
const getTxs = async () => {
    //@ts-ignore
    return wallet.getTxs();
};
exports.getTxs = getTxs;
const isWalletSynced = async () => {
    return wallet.isSynced();
};
exports.isWalletSynced = isWalletSynced;
const isWalletConnected = async () => {
    return wallet.isConnectedToDaemon();
};
exports.isWalletConnected = isWalletConnected;
const relayTxs = async (metaDataList) => {
    return wallet.relayTxs(metaDataList);
};
exports.relayTxs = relayTxs;
const setDaemonConnection = async (connection) => {
    //@ts-ignore
    return wallet.setDaemonConnection(connection);
};
exports.setDaemonConnection = setDaemonConnection;
const getKeys = async () => {
    const publicSpend = await wallet.getPublicSpendKey();
    const privateSpend = await wallet.getPrivateSpendKey();
    const publicView = await wallet.getPublicViewKey();
    const privateView = await wallet.getPrivateViewKey();
    const mnemonic = await wallet.getMnemonic();
    return {
        publicSpend,
        privateSpend,
        publicView,
        privateView,
        mnemonic,
    };
};
exports.getKeys = getKeys;
const addWalletListener = (listener) => {
    // @ts-ignore
    wallet.addListener(listener);
};
exports.addWalletListener = addWalletListener;
const getSubAddresses = async () => {
    //@ts-ignore
    return wallet.getSubaddresses(0);
};
exports.getSubAddresses = getSubAddresses;
const createSubAddress = async (label) => {
    //@ts-ignore
    return wallet.createSubaddress(0, label);
};
exports.createSubAddress = createSubAddress;
const labelAddress = async (label, addressIndex) => {
    throw "not implemented yet";
};
exports.labelAddress = labelAddress;
const getIntegratedAddress = async (paymentId) => {
    //@ts-ignore
    return wallet.getIntegratedAddress(paymentId);
};
exports.getIntegratedAddress = getIntegratedAddress;
const setSyncHeight = (syncHeight) => {
    return wallet.setSyncHeight(syncHeight);
};
exports.setSyncHeight = setSyncHeight;
const getSyncHeight = () => {
    return wallet.getSyncHeight();
};
exports.getSyncHeight = getSyncHeight;
const rescanBlockchain = async () => {
    return wallet.rescanBlockchain();
};
exports.rescanBlockchain = rescanBlockchain;
const isClosed = async () => {
    return wallet.isClosed();
};
exports.isClosed = isClosed;
const rescanSpent = () => {
    return wallet.rescanSpent();
};
exports.rescanSpent = rescanSpent;
const saveWallet = () => {
    return wallet.save();
};
exports.saveWallet = saveWallet;
const getAddressBookEntries = async (entryIndices = []) => {
    return wallet.getAddressBookEntries(entryIndices);
};
exports.getAddressBookEntries = getAddressBookEntries;
const addAddressBookEntry = async (address, description) => {
    return wallet.addAddressBookEntry(address, description);
};
exports.addAddressBookEntry = addAddressBookEntry;
const editAddressBookEntry = async (index, setAddress, address, setDescription, description) => {
    return wallet.editAddressBookEntry(index, setAddress, address, setDescription, description);
};
exports.editAddressBookEntry = editAddressBookEntry;
const deleteAddressBookEntry = async (entryIdx) => {
    return wallet.deleteAddressBookEntry(entryIdx);
};
exports.deleteAddressBookEntry = deleteAddressBookEntry;
