"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getAvailableWallets = void 0;
const fs = __importStar(require("fs"));
const path = __importStar(require("path"));
const env_1 = require("../env");
const oldPaths = ["/xvault3/main", "/xvault3/test", "/xvault3/stage"];
const newPaths = ["/xvault4/main", "/xvault4/test", "/xvault4/stage"];
const getOldWalletPath = (netTypeId) => {
    return path.join(env_1.APP_DATA_PATH, oldPaths[netTypeId]);
};
const getWalletPath = (netTypeId) => {
    return path.join(env_1.APP_DATA_PATH, newPaths[netTypeId]);
};
const getOrConstructWalletPath = (netTypeId) => {
    const walletPath = getWalletPath(netTypeId);
    if (!fs.existsSync(walletPath)) {
        // create new wallet folder
        fs.mkdirSync(walletPath, { recursive: true });
        //check for old wallet folder and copy over keys files
        const oldPath = getOldWalletPath(netTypeId);
        if (fs.existsSync(oldPath)) {
            const oldWallets = fs.readdirSync(oldPath);
            const keyFiles = oldWallets
                .filter((file) => file.endsWith(".keys"));
            for (const file of keyFiles) {
                const oldFile = path.join(oldPath, file);
                const newFile = path.join(walletPath, file);
                fs.copyFileSync(oldFile, newFile);
            }
        }
    }
    return walletPath;
};
const getAvailableWallets = (netTypeId) => {
    const walletPath = getOrConstructWalletPath(netTypeId);
    let availableWallets;
    const files = fs.readdirSync(walletPath);
    availableWallets = files
        .filter((file) => file.endsWith(".keys"))
        .map((walletName) => {
        walletName = walletName.replace(".keys", "");
        return walletName;
    });
    return {
        storePath: walletPath,
        wallets: availableWallets,
    };
};
exports.getAvailableWallets = getAvailableWallets;
